<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;
use App\Http\Base\BaseModel;

class PenggunaanbarangModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "penggunaanbarang";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "penggunaanbarang";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* check the incrementing boolean if the incrementing from database is false then the value is false by default
	*/
	// public $incrementing = false;
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable = [
		"id", "miNumber", "requesterId", "approverId", "transactionType", "kapalId", "locationId", "destinationAccount", "tglPenggunaan", "jlhBarang", "voyageKode", "voyageStart", "voyageEnd", "date_updated"
	];
	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"miNumber" => "penggunaanbarang.miNumber",
		"tglPenggunaan" => "penggunaanbarang.tglPenggunaan", 
		"destinationAccount" => "penggunaanbarang.destinationAccount",
		"voyageKode" => "penggunaanbarang.voyageKode",
		"voyageStart" => "penggunaanbarang.voyageStart",
		"voyageEnd" => "penggunaanbarang.voyageEnd"
	];

	/**
	* relation from ' . kapal . ' by ' . kapalId 
	* join kapal on kapal.id = penggunaanbarang.kapalId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationKapalId($alias = "kapalId")
	{
		$this->getQuery()->leftjoin("kapal as $alias", "$alias.id", "=", "penggunaanbarang.kapalId");
		return $this;
	}
	/**
	* relation from ' . lokasiitem . ' by ' . locationId 
	* join lokasiitem on lokasiitem.id = penggunaanbarang.locationId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationLocationId($alias = "locationId")
	{
		$this->getQuery()->leftjoin("lokasiitem as $alias", function ($join) use ($alias) {
			$join->on("$alias.id", "=", "penggunaanbarang.locationId");
		});
		// "$alias.id", "=", "penggunaanbarang.locationId");
		return $this;
	}
	/**
	* relation from ' . users . ' by ' . approverId 
	* join users on users.id = penggunaanbarang.approverId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationApproverId($alias = "approverId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "penggunaanbarang.approverId");
		return $this;
	}
	/**
	* relation from ' . users . ' by ' . requesterId 
	* join users on users.id = penggunaanbarang.requesterId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationRequesterId($alias = "requesterId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "penggunaanbarang.requesterId");
		return $this;
	}
	/**
	* relation from ' . itempenggunaanbarang . ' by ' . penggunaanBarangId 
	* join itempenggunaanbarang on itempenggunaanbarang.penggunaanBarangId = penggunaanbarang.id
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationItempenggunaanbarangId($alias = "itempenggunaanbarang_")
	{
		$this->getQuery()->join("itempenggunaanbarang_ as $alias", "$alias.miNumber", "=", "penggunaanbarang.miNumber");
		return $this;
	}

	public function joinRelationAccountId($alias = "accountId")
	{
		$this->getQuery()->leftjoin("account as $alias", "$alias.noAccount", "=", "penggunaanbarang.destinationAccount");
		return $this;
	}

	public function joinRelationVoyageKode($alias = "voyageKode")
	{
		$this->getQuery()->leftjoin("voyages as $alias", function($join) use ($alias) {
			$join->on("$alias.voyageKode", "=", "penggunaanbarang.voyageKode");
			$join->on("$alias.kapalId", "=", "penggunaanbarang.kapalId");
		});
		return $this;
	}
}
